贪心 —— POJ 1017 Packets

2024-09-05 04:08
文章标签 贪心 poj 1017 packets

本文主要是介绍贪心 —— POJ 1017 Packets,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

对应POJ题目:点击打开链接

Packets
Time Limit: 1000MS Memory Limit: 10000K
Total Submissions: 46584 Accepted: 15752

Description

A factory produces products packed in square packets of the same height h and of the sizes 1*1, 2*2, 3*3, 4*4, 5*5, 6*6. These products are always delivered to customers in the square parcels of the same height h as the products have and of the size 6*6. Because of the expenses it is the interest of the factory as well as of the customer to minimize the number of parcels necessary to deliver the ordered products from the factory to the customer. A good program solving the problem of finding the minimal number of parcels necessary to deliver the given products according to an order would save a lot of money. You are asked to make such a program.

Input

The input file consists of several lines specifying orders. Each line specifies one order. Orders are described by six integers separated by one space representing successively the number of packets of individual size from the smallest size 1*1 to the biggest size 6*6. The end of the input file is indicated by the line containing six zeros.

Output

The output file contains one line for each line in the input file. This line contains the minimal number of parcels into which the order from the corresponding line of the input file can be packed. There is no line in the output file corresponding to the last ``null'' line of the input file.

Sample Input

0 0 4 0 0 1 
7 5 1 0 0 0 
0 0 0 0 0 0 

Sample Output

2 
1 

题意:

装箱问题  

    问题描述 
    一个工厂制造的产品形状都是长方体,它们的高度都是h,长和宽都相等,一共有六个 
型号,他们的长宽分别为 1*1, 2*2, 3*3, 4*4, 5*5, 6*6.  这些产品通常使用一个  6*6*h       

的长方体包裹包装然后邮寄给客户。因为邮费很贵,所以工厂要想方设法的减小每个订单运送时的 
包裹数量。他们很需要有一个好的程序帮他们解决这个问题从而节省费用。现在这个程序由 
你来设计。  
    输入数据  
    输入文件包括几行,每一行代表一个订单。每个订单里的一行包括六个整数,中间用空 
格隔开,分别为 1*1 至6*6 这六种产品的数量。输入文件将以 6 个0 组成的一行结尾。  
    输出要求  
    除了输入的最后一行6 个0 以外,输入文件里每一行对应着输出文件的一行,每一行输 
出一个整数代表对应的订单所需的最小包裹数。  
    输入样例 
    0 0 4 0 0 1   
    7 5 1 0 0 0   
    0 0 0 0 0 0   
      
    输出样例  
    2   
    1  


思路:

高度无需考虑,只考虑面积就行。假设输入a1, a2, a3, a4, a5, a6

从面积最大的开始处理,可知,对于6*6大小的箱子,6*6的物品会霸占一个箱子;5*5的物品会余下11个能装1*1物品的空间;4*4的物品会余下20个1*1的空间,可以放2*2和1*1的物品;对于3*3的物品,所需的箱子数就是(a3 + 3) / 4(即是a3除以4向上取整),然后余数为0就刚好放完;为1就剩下27个1*1的空间,为2就剩下18个1*1的空间,为3就剩下9个1*1的空间;然后把2*2和1*1的物品尽可能多地往已用的箱子里面塞;多出的向上取整。

这题用到几个技巧可以缩短代码量,做完后观看网上的代码,好短~

本人代码:

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>int main()
{int a1, a2, a3, a4, a5, a6;int i, ans;int b, r, c, p, all;//freopen("in.txt", "r", stdin);while(scanf("%d%d%d%d%d%d", &a1, &a2, &a3, &a4, &a5, &a6) == 6){if(0 == a1 + a2 + a3 + a4 + a5 + a6) break;ans = a6 + a5 + a4;c = 0;b = 5 * a4;ans += (a3 + 3) / 4;r = a3 % 4;if(1 == r) c = 5;else if(2 == r) c = 3;else if(3 == r) c = 1;b += c;p = 0;if(r) p = 36 - 9 * r;all = 11 * a5 + 20 * a4 + p;//if(b > a2){all -= 4 * (b - a2); a2 = 0;}if(b > a2){all -= 4 * a2; a2 = 0;}else{a2 -= b; all -= 4 * b;}if(all > a1) a1 = 0;else a1 -= all;ans += (a2 + 8) / 9;r = a2 % 9;all = 36 - 4 * r;if(r){if(all > a1) a1 = 0;else a1 -= all;}ans += (a1 + 35) / 36;printf("%d\n", ans);}return 0;
}

模仿网上代码:

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>int main()
{//freopen("in.txt", "r", stdin);int a1, a2, a3, a4, a5, a6;int b, x, ans;int r[] = {0, 5, 3, 1};while(scanf("%d%d%d%d%d%d", &a1, &a2, &a3, &a4, &a5, &a6) == 6){if(0 == a1 + a2 + a3 + a4 + a5 + a6) break;ans = a6 + a5 + a4 + (a3 + 3) / 4; //4*4,5*5,6*6都可以占一个箱子b = 5 * a4 + r[a3%4]; //计算目前为止所开的箱子能够装下2*2的物品的最大数量if(a2 > b) ans += (a2 - b + 8) / 9; //2*2的物品大于最大数量,应为剩下的开新的箱子x = 36 * ans - 36 * a6 - 25 * a5 - 16 * a4 - 9 * a3 - 4 * a2; //计算目前为止所开的箱子能够装下1*1的物品的最大数量if(a1 > x) ans += (a1 - x + 35) / 36; //1*1的物品大于最大数量,应为剩下的开新的箱子;printf("%d\n", ans);}return 0;
}












这篇关于贪心 —— POJ 1017 Packets的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1137903

相关文章

usaco 1.3 Barn Repair(贪心)

思路:用上M块木板时有 M-1 个间隙。目标是让总间隙最大。将相邻两个有牛的牛棚之间间隔的牛棚数排序,选取最大的M-1个作为间隙,其余地方用木板盖住。 做法: 1.若,板(M) 的数目大于或等于 牛棚中有牛的数目(C),则 目测 给每个牛牛发一个板就为最小的需求~ 2.否则,先对 牛牛们的门牌号排序,然后 用一个数组 blank[ ] 记录两门牌号之间的距离,然后 用数组 an

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一